Attribute VB_Name = "modCallBack"
' This module was simply added because of VB's inability to handle
' callbacks in forms. You can only call functions located in modules.
' Don't bother adding any if you don't want to use callbacks; however,
' it IS polite to allow the user an opportunity to abort the process.
Option Explicit
DefLng A-Z

Public Const LongArraySize As Long = 100000
Public Const SingleArraySize As Long = 100000
Public Const StringArraySize As Long = 100000
Public LongArray(LongArraySize - 1) As Long
Public SingleArray(SingleArraySize - 1) As Single
Public StringArray(StringArraySize - 1) As String

Public Counter As Long             'generic counting variable
Public SubCounter As Long
Public EscCallbacks As Long        'number of callbacks (purely informative)
Public AbortSort As Boolean        'abort the sort!!

'internal DLL comparison callbacks
Public Const CmpLongAsc  As Long = 0 '<- 32bit signed integers
Public Const CmpLongDesc As Long = 1
Public Const CmpSngAsc   As Long = 2 '<- floating point singles
Public Const CmpSngDesc  As Long = 3
Public Const CmpStrAscA  As Long = 4 '<- for C strings (ASCII)
Public Const CmpStrDescA As Long = 5
Public Const CmpStrAscW  As Long = 6 '<- for Unicode C strings (Widebyte)
Public Const CmpStrDescW As Long = 7
Public Const CmpStrAscB  As Long = 8 '<- for Visual Basic 4+ strings (BSTRs)
Public Const CmpStrDescB As Long = 9

'This callback is called each entire pass through the array
'It provides the caller a chance to show progress and check for
'messages in case the user wants to abort.
Public Function EscCallBack() As Long
    On Error Resume Next
    EscCallbacks = EscCallbacks + 1
    frmTestSort.Caption = EscCallbacks & " escape calls"
    DoEvents
    EscCallBack = AbortSort
End Function

'Simply compares two longs and returns True (that should be swapped)
'if they are not already in ascending order
Public Function CmpLongAscCb(ByRef First As Long, ByRef Second As Long) As Long
    If First > Second Then CmpLongAscCb = True
End Function

'Simply compares two singles and returns True (that should be swapped)
'if they are not already in ascending order
Public Function CmpSngAscCb(ByRef First As Single, ByRef Second As Single) As Long
    If First > Second Then CmpSngAscCb = True
End Function

'Simply compares two strings and returns True (that should be swapped)
'if they are not already in ascending order
Public Function CmpStrAscCb(ByRef First As String, ByRef Second As String) As Long
    If First > Second Then CmpStrAscCb = True
End Function
