VERSION 5.00
Begin VB.Form frmTestSort 
   Caption         =   "Test Sort"
   ClientHeight    =   6510
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   Icon            =   "TestSort.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6510
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkInternalCb 
      Caption         =   "Internal Callback"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      ToolTipText     =   "Use faster internal DLL callback or slower VB callback"
      Top             =   3240
      Value           =   1  'Checked
      Width           =   1215
   End
   Begin VB.CommandButton cmdAbort 
      Cancel          =   -1  'True
      Caption         =   "Abort"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "Signals the ordering routine to abort"
      Top             =   1320
      Width           =   1215
   End
   Begin VB.OptionButton optStrings 
      Caption         =   "Strings"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      ToolTipText     =   "Orders OLE2 BTSRs using internal callback"
      Top             =   2760
      Width           =   1215
   End
   Begin VB.OptionButton optSingles 
      Caption         =   "Singles"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      ToolTipText     =   "Orders IEEE 32bit reals"
      Top             =   2400
      Width           =   1215
   End
   Begin VB.OptionButton optLongs 
      Caption         =   "Longs"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "Orders signed 32bit integers using internal callback"
      Top             =   2040
      Value           =   -1  'True
      Width           =   1215
   End
   Begin VB.CommandButton cmdSort 
      Caption         =   "Sort"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "Starts ordering the selected array type"
      Top             =   720
      Width           =   1215
   End
   Begin VB.ListBox lstValues 
      Height          =   6300
      Left            =   1440
      TabIndex        =   6
      Top             =   120
      Width           =   3135
   End
   Begin VB.CommandButton cmdRandomize 
      Caption         =   "Randomize"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Randomizes the selected array type"
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmTestSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Ordering example using Comb sort
'Example of DLL calls and VB callbacks
'
'The DLL was written in assembler for SPEED :)
'The called ordering routine can theoretically order any kind of 32bit data,
'because it doesn't do any comparisons itself. Instead, it uses a called
'function to tell it whether or not to swap (yes, it's an old concept).
'
'The DLL includes a few built in comparison functions for the most common
'types of data (32bit signed integers, floating point singles, typical null
'terminated char strings, Unicode strings, and VB strings). Each type includes
'both ascending and descending order. For other types of data, or for other
'less common preferences of sorting, a callback can be given. For example,
'imagine you want to sort an array of color values (32bit integers) by
'brightness (sum of R+G+B).
'
'This example includes both internal (within the DLL) and external (routines
'in VB) callbacks. Unless you have special ordering needs, use the internal
'ones because as you will notice, (no surprise) they are siginificantly faster.
'The example VB callbacks are just that, examples. I find it strange that the
'VB FPU callback is actually faster than the integer callback. Also, I must
'give VB credit for their string comparison. Mine is only three times faster,
'and honestly I expected it to be more.
'
'This was tested on a 350MHz machine, so if yours is slower, reduce the
'size of the arrays to lessen intolerable waiting.
'
'                         Unsorted            Already Ordered
'                   External    Internal    External    Internal
' 100,000 longs      9.8          .89        3.2         .26
' 100,000 singles    9.6         1.02        3.1         .30
' 100,000 strings   16.4         6.14        5.4        2.00
'
'The results above are averages of the tests after the first one, since the
'first test was always slower than later ones (in both internal and external),
'probably something to do with uncached memory or something similar. The comb
'ordering routine performs well on already ordered data too, taking a third as
'long as unordered data.
'
'
'The code this was based on (from www.vbcode.com)
'
'    Dim I, J, Temp As Integer
'    Const Shrink = 1.3
'    Dim Gap As Single
'    Dim Swapped As Boolean
'    Gap = Arrsize - 1
'    
'    Do
'        Gap = Int(Gap / Shrink)
'        Swapped = True
'        Combcom = Combcom + 1
'        For J = 0 To Arrsize - Gap
'            If Array3(J) > Array3(J + Gap) Then
'            Temp = Array3(J)
'            Array3(J) = Array3(J + Gap)
'            Array3(J + Gap) = Temp
'            Swapped = False
'            Combswap = Combswap + 1
'            End If
'        Next J
'    Loop Until Not Swapped And Gap = 1
'
'    For I = 0 To Arrsize
'       lstcomb.AddItem Array3(I)
'    Next I
'
'
'Just happened to be listening to this cool song while writing this:
'Kaliya - Ritual Tibetan (Gigi D'Agostino Remix (Radio Mix))

Option Explicit
DefLng A-Z

'Note that VB to find this DLL you must either:
' -Start it from the project (NOT open VB and then simply open the project) so
'  that the current directory points correctly. In other words, double click
'  on the VBP file.
' -Include the full path in the Lib statement below.
' -Compile the program and run that.
' -Copy the DLL to WINDOWS\SYSTEM (bad choice).
Private Declare Sub CombOrder Lib "asmorder.dll" (ByRef ArrayPtr As Any, ByVal ArraySize As Long, ByVal CmpCb As Long, ByVal EscCb As Long)

Private Sub cmdAbort_Click()
AbortSort = True
Caption = "Aborting sort"
End Sub

Private Sub cmdRandomize_Click()

Caption = "Randomizing values..."
DoEvents

If optLongs.Value Or LongArray(0) = 0 Then
    For Counter = 0 To LongArraySize - 1
        LongArray(Counter) = Int(Rnd * 10000) - 5000
    Next
End If
If optSingles.Value Or SingleArray(0) = 0 Then
    For Counter = 0 To SingleArraySize - 1
        SingleArray(Counter) = (Rnd * 10000) - 5000
    Next
End If
If optStrings.Value Or Len(StringArray(0)) <= 0 Then
    Dim TempStr As String
    For Counter = 0 To StringArraySize - 1
        TempStr = Space$(Int(Rnd * 5) + 10)
        For SubCounter = 1 To Len(TempStr)
            Mid$(TempStr, SubCounter, 1) = Chr$(Int(Rnd * 26) + 65)
        Next
        StringArray(Counter) = TempStr
    Next
End If

AddListItems
Caption = "Test Sort"

End Sub

Private Sub cmdSort_Click()
Dim StartTime As Single, EndTime As Single
Dim Entries As Long
Dim InternalCb As Boolean

EscCallbacks = 0
AbortSort = False
cmdAbort.Enabled = True
cmdSort.Enabled = False
cmdRandomize.Enabled = False
InternalCb = chkInternalCb.Value

StartTime = Timer
Select Case True
Case optLongs.Value
    If InternalCb Then
        CombOrder LongArray(0), LongArraySize, CmpLongAsc, AddressOf EscCallBack
    Else
        CombOrder LongArray(0), LongArraySize, AddressOf CmpLongAscCb, AddressOf EscCallBack
    End If
    Entries = LongArraySize
Case optSingles.Value
    If InternalCb Then
        CombOrder SingleArray(0), SingleArraySize, CmpSngAsc, AddressOf EscCallBack
    Else
        CombOrder SingleArray(0), SingleArraySize, AddressOf CmpSngAscCb, AddressOf EscCallBack
    End If
    Entries = SingleArraySize
Case optStrings.Value
    If InternalCb Then
        CombOrder ByVal VarPtr(StringArray(0)), StringArraySize, CmpStrAscB, AddressOf EscCallBack
    Else
        CombOrder ByVal VarPtr(StringArray(0)), StringArraySize, AddressOf CmpStrAscCb, AddressOf EscCallBack
    End If
    Entries = StringArraySize
End Select
EndTime = Timer

Caption = Entries & " array entries in " & EndTime - StartTime & " seconds"
cmdAbort.Enabled = False
cmdSort.Enabled = True
cmdRandomize.Enabled = True
AddListItems

End Sub

Private Sub Form_Load()
Show
cmdRandomize_Click
End Sub

Private Sub optLongs_Click()
AddListItems
End Sub

Private Sub optSingles_Click()
AddListItems
End Sub

Private Sub optStrings_Click()
AddListItems
End Sub

Private Sub AddListItems()
Dim CountStep As Long

lstValues.Clear
Select Case True
Case optLongs.Value
    CalcCounterStep LongArraySize, 5000, CountStep
    For Counter = 0 To LongArraySize - 1 Step CountStep
        lstValues.AddItem Str$(LongArray(Counter))
    Next
Case optSingles.Value
    CalcCounterStep SingleArraySize, 5000, CountStep
    For Counter = 0 To SingleArraySize - 1 Step CountStep
        lstValues.AddItem Str$(SingleArray(Counter))
    Next
Case optStrings.Value
    CalcCounterStep StringArraySize, 5000, CountStep
    For Counter = 0 To StringArraySize - 1 Step CountStep
        lstValues.AddItem StringArray(Counter)
    Next
End Select

End Sub

'Loading over 5000 entries takes too long, so calculate
'a step count for the FOR loop to skip every few items.
Private Sub CalcCounterStep(LoopCount, LoopMax, CountStep)

If LoopCount > LoopMax Then
    CountStep = LoopCount \ LoopMax
Else
    CountStep = 1
End If

End Sub
